<?php
/**
 * @package    WordPress
 * @subpackage Time
 * @since      1.0
 */

$banner = Time::io_('layout/banner/banner', 'banner/content', '__hidden_ns');

?>

<?php if ($banner->value('type') == 'empty' && $banner->value('height')): // Empty ?>

	<div class="under-container banner-empty" style="position: relative; height: <?php echo $banner->value('height'); ?>px;">
		<?php get_template_part('parts/background', 'open'); ?>
	</div>

<?php elseif ($banner->value('type') == 'image' && $banner->value('image')): // Image ?>

	<div class="outer-container banner-image transparent">
		<?php get_template_part('parts/background', 'open'); ?>
		<div>
			<figure class="full-width">
				<?php echo wp_get_attachment_image($banner->value('image'), Time::to('general/layout') == 'boxed' ? 'banner' : 'full-hd'); ?>
			</figure>
		</div>
	</div>

<?php elseif ($banner->value('type') == 'thumbnail' && has_post_thumbnail()): // Featured image ?>

	<div class="outer-container banner-thumbnail transparent">
		<?php get_template_part('parts/background', 'open'); ?>
		<div>
			<figure class="full-width">
				<?php the_post_thumbnail(Time::to('general/layout') == 'boxed' ? 'banner' : 'full-hd'); ?>
			</figure>
		</div>
	</div>

<?php elseif ($banner->value('type') == 'slider'): // Slider ?>

	<div class="under-container banner-slider">
		<?php get_template_part('parts/background', 'open'); ?>
		<div class="container">
			<?php Time::layerSliderSlider($banner->value('slider')); ?>
		</div>
	</div>

<?php elseif ($banner->value('type') == 'custom'): // Custom ?>

	<div class="outer-container banner-custom transparent">
		<?php get_template_part('parts/background', 'open'); ?>
		<div class="container">
			<?php echo \Drone\Func::wpProcessContent($banner->value('custom')); ?>
		</div>
	</div>

<?php endif; ?>