<?php
/**
 * Review Comments Template
 *
 * Closing li is left out on purpose!.
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/review.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you (the theme developer).
 * will need to copy the new files to your theme to maintain compatibility. We try to do this.
 * as little as possible, but it does happen. When this occurs the version of the template file will.
 * be bumped and the readme will list any important changes.
 *
 * @see     http://docs.woothemes.com/document/template-structure/
 * @author  WooThemes
 * @package WooCommerce/Templates
 * @version 2.5.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

$rating   = intval( get_comment_meta( $comment->comment_ID, 'rating', true ) );
$verified = wc_review_is_from_verified_owner( $comment->comment_ID );

?>

<?php // # BEGIN Time ?>

<li itemprop="review" itemscope itemtype="http://schema.org/Review" id="li-comment-<?php comment_ID() ?>">

	<div id="comment-<?php comment_ID(); ?>" class="comment_container comment">

		<figure class="alignleft fixed inset-border">
			<?php echo get_avatar( $comment, apply_filters( 'woocommerce_review_gravatar_size', '50' ), '' ); ?>
		</figure>

		<p class="info">

			<?php do_action( 'woocommerce_review_before_comment_meta', $comment ); ?>

			<?php if ( $rating && get_option( 'woocommerce_enable_review_rating' ) === 'yes' ) : ?>

				<?php echo Time::getInstance()->filterWoocommerceProductGetRatingHTML(null, $rating); ?>

			<?php endif; ?>

			<?php
				if ( get_option( 'woocommerce_review_rating_verification_label' ) === 'yes' )
					if ( $verified )
						echo '<small class="verified">(' . __( 'verified owner', 'woocommerce' ) . ')</small> ';
			?>

			<strong itemprop="author"><?php comment_author(); ?></strong>

			<?php if ( Time::to( 'site/comments/date_format' ) ): ?>
				, <time class="small" itemprop="datePublished" datetime="<?php echo get_comment_date( 'c' ); ?>"><?php
					switch ( Time::to( 'site/comments/date_format' ) ) {
						case 'relative':
							printf( __( '%s ago', 'timme' ), human_time_diff( get_comment_time( 'U', true ) ) );
							break;
						case 'absolute':
							printf( __( '%1$s at %2$s', 'timme' ), get_comment_date(), get_comment_time() );
							break;
					}
				?></time>
			<?php endif; ?>

		</p>

		<div class="comment-text text">

			<?php if ( $comment->comment_approved == '0' ) : ?>

				<p class="meta"><em><?php _e( 'Your comment is awaiting approval', 'woocommerce' ); ?></em></p>

			<?php endif; ?>

			<?php do_action( 'woocommerce_review_before_comment_text', $comment ); ?>

			<div itemprop="description" class="description"><?php comment_text(); ?></div>

			<?php do_action( 'woocommerce_review_after_comment_text', $comment ); ?>

		</div>

	</div>

<?php // # END Time ?>